//----------------------------------
//  AFFICHAGE EN 16 FAUSSES COULEURS
//----------------------------------

// Librairies
  #include <dos.h>
  #include <math.h>
  #include <stdlib.h>
  #include <ctype.h>
  #include <stdio.h>
  #include <conio.h>
  #include <graphics.h>
// Constantes
  #define ROUGE   0
  #define VERT    1
  #define BLEU    2
  #define GRIS    3
  #define COULEUR 4
  #define ESC	0x1b
// Chemins
  #define DRIVER ""
  #define MISS "miss." 
// Graphismes
  struct palettetype pal;
  void   Affiche_Image     (unsigned char ***, short, short, short, short, short);
  void   Histogramme_Image (unsigned char ***, float ***,short, short, short, short, short, short, short, short, short, short);
  void   Decomposition_Binaire (short,short *);
  short  Conversion (short);
  void   Affiche_Palette (short, short, short, short);
  void	Palette_Systeme (void);
// Gestion de la mmoire
  unsigned char *** Reservation_Tenseur_UC ( long, long, long, long, long);
  void Liberation_Tenseur_UC    (unsigned char ***, long, long, long, long, long);
  float ***f3tensor(long , long , long , long , long , long );
  void free_f3tensor(float ***, long , long , long , long ,long , long );
// Gestion de la souris
  union REGS pregs;
  void  Souris_Cache             (void);
  void  Souris_Affichage         (void);
  short Souris_Clic              (void);
  short xsouris                  (void);
  short ysouris                  (void);  
  void  Souris_Definition_Curseur(char);  
  void  Souris_Deplacement       (short, short);
  short Souris_Zone              (short, short, short, short);
  short Souris_Clic_Gauche_Zone  (short, short, short, short);
  short Souris_Clic_Droit_Zone   (short, short, short, short);
  void  Souris_Limite            (short, short, short, short);
  void  Souris_Exclusion         (short, short, short, short);
// Interface
  void BoutonInverse(short ,short, short, short, char [20]);
  void Bouton       (short ,short, short, short, char [20]);
// Variables globales
  struct palettetype palette, palettesysteme;
  struct element {float nombre; short rouge; short vert; short bleu;};
  typedef struct element ELEMENT;
// Numerical Recipes
  void shell(short,ELEMENT []);

//************************************************************************************************************************
void main(void)
 {
  int driver = DETECT, mode;
  short i,j,k,l,couleur,Distance_Min,affichagepetitepalette=0,affichagegrandepalette=0;
  float ***FO, ***Histogramme;
  char reponse;
  unsigned char ***ImageMiss,pixel;
  FILE *fichier;
  ELEMENT Occurence[100];
	 // Mode graphique
	 initgraph(&driver,&mode,DRIVER);
	 getpalette (&palette);
	 Palette_Systeme ();
	 // Trac de l'interface
	 setfillstyle(SOLID_FILL, LIGHTGRAY);
	 setcolor (LIGHTGRAY);
	 bar(0, 0, 85, getmaxy());
	 rectangle(0, 0 ,getmaxx(), getmaxy());
	 rectangle(1, 1 ,getmaxx()-1, getmaxy()-1);
	 rectangle(2, 2 ,getmaxx()-2, getmaxy()-2);
	 rectangle(3, 3 ,getmaxx()-3, getmaxy()-3);
	 rectangle(4, 4 ,getmaxx()-4, getmaxy()-4);	 
	 setcolor(WHITE);
	 line( getmaxx()-4, 5, getmaxx()-4, getmaxy()-4);
	 line( 86, getmaxy()-4, getmaxx()-4, getmaxy()-4);
	 line(0, 0, getmaxx(),0);
	 line (0, 0,0, getmaxy());
	 setcolor(DARKGRAY);
	 line( 0, 479, 639, 479);
	 line( 85, 4, 635,4);
	 line(639, 0, 639,479);
	 line (85, 4,85, 475);
	 Bouton(5,  20, 80,  40, "COULEUR");
	 Bouton(5,  43, 80,  63, "ROUGE");
	 Bouton(5,  66, 80,  86, "VERT");
	 Bouton(5,  89, 80, 109, "BLEU");
	 Bouton(5, 112, 80, 132, "GRIS");
	 Bouton(5, 135, 80, 155, "HISTOGRAMME");
	 Bouton(5, 158, 80, 178, "EFFACER");
	 Bouton(5, 181, 80, 201, "PALETTE");
	 Bouton(5, 204, 80, 224, "QUITTER");
	 setcolor (WHITE);
	 settextjustify(LEFT_TEXT, CENTER_TEXT);
	 outtextxy (250, 220, "Traitement en cours... patientez");
	 getpalette (&palettesysteme);
	 getpalette (&palette);
	 Souris_Affichage();	 
	 Souris_Definition_Curseur('c');  
	 // Rservation mmoire pour l'image RGB
	 ImageMiss = Reservation_Tenseur_UC(5, 0, 255, 0, 255); // 5 plans : RGB + moyenne RGB + image rduite  16 couleurs
	 // Ouverture du fichier en lecture binaire
	 fichier = fopen (MISS, "rb");
	 // Lecture et stockage
	 if (ImageMiss != NULL && fichier != NULL)
		for (couleur = 0; couleur <= 2; couleur ++)
		  for (j = 0; j < 256; j ++)
			 for (i = 0; i < 256; i ++)
			  {
				fread(&pixel, 1, 1, fichier);
				ImageMiss[couleur][i][j] = Conversion(pixel)*16;
			  }
	 else
	  {
		printf ("\n Problme  l'ouverture du fichier image en lecture ou rservation mmoire");
		getch ();
	  }
	 fclose (fichier);
	 // Gnration de l'image en niveaux de gris (moyenne des 3 composantes RGB)
		for (j = 0; j < 256; j ++)
		  for (i = 0; i < 256; i ++)
			 ImageMiss[GRIS][i][j] = (ImageMiss[ROUGE][i][j]  +
			 ImageMiss[VERT][i][j] + ImageMiss[BLEU][i][j]) / 3;
	 // Gnration du tenseur FO
	 FO = f3tensor(0, 15, 0, 15,0,15);
	 // Initialisation de FO  0
	 for (i =0; i < 16; i ++)
		for (j =0; j < 16; j ++)
		  for (k = 0; k < 16; k ++)
			 FO[i][j][k] = 0.;
	 // Remplissage de FO
	 for (j = 0; j < 256; j ++)
		for (i = 0; i < 256; i ++)
		 {
		  FO[ ImageMiss[ROUGE][i][j]/16 ]
			 [ ImageMiss[VERT][i][j] /16 ]
			 [ ImageMiss[BLEU][i][j] /16 ] += 1.;
		 }
  // Tableau de structures d'occurences  0
  for (i = 0; i < 100; i ++)
	Occurence[i].nombre = 0.;
  l = 1;
  for (i = 0; i < 16; i ++)
	 for (j = 0; j < 16; j ++)
		for (k = 0; k < 16; k ++)
		 {
		  if ( (FO[i][j][k] > 50.) && (l <101))
			{
			 Occurence[l].nombre = FO[i][j][k];
			 Occurence[l].rouge = i;
			 Occurence[l].vert = j;
			 Occurence[l].bleu = k;
			 l ++;
			}
		 }
  shell(100, Occurence); // tri
  // Rcriture du fichier image en niveaux RGB les plus frquents par la mthode de la distance Euclidienne minimale
  for (i = 0; i < 256; i ++)
	 for (j = 0; j < 256; j ++)
	  {
		Distance_Min = (sqrt(3*15*15));// Distance maxi dans le tenseur FO
		// Recherche de la distance minimale
		for ( k = 0; k < 16; k++)
		 {
		  if ( sqrt( pow((ImageMiss[ROUGE][i][j]/16 - Occurence[99-k].rouge),2)+
						 pow((ImageMiss[VERT] [i][j]/16 - Occurence[99-k].vert ),2)+
						 pow((ImageMiss[BLEU] [i][j]/16 - Occurence[99-k].bleu ),2))
						 < Distance_Min )
			{
			 Distance_Min =
				 sqrt( pow((ImageMiss[ROUGE][i][j]/16 - Occurence[99-k].rouge),2)+
						 pow((ImageMiss[VERT] [i][j]/16 - Occurence[99-k].vert ),2)+
						 pow((ImageMiss[BLEU] [i][j]/16 - Occurence[99-k].bleu ),2));
			 pixel = (unsigned char)k;
			}
		 }
		ImageMiss[4][i][j] = pixel*16;
	  }
	 setcolor (BLACK);
	 settextjustify(LEFT_TEXT, CENTER_TEXT);
	 outtextxy (250, 220, "Traitement en cours... patientez");
	 do
	  {
		// Affichage de l'image MISS en couleur
		if (Souris_Clic_Gauche_Zone(5, 20, 80, 40) == 1)
		 {
		  setviewport(86, 5, 634, 474,1);
		  clearviewport ();
		  setviewport(0, 0,639, 479,1);			
		  BoutonInverse(5,  20, 80,  40, "COULEUR");
		  delay (200);
		  Bouton(5,  20, 80,  40, "COULEUR");
		  getpalette (&palette);
		  for (i = 0; i < palette.size; i++ )
			 setrgbpalette (palette.colors[i], Occurence[99-i].rouge * 4,Occurence[99-i].vert  * 4 ,Occurence[99-i].bleu  * 4 );
		  setviewport(234, 111,490, 367,1);
		  Affiche_Image (ImageMiss, 0, 255, 0, 255, COULEUR);
		  setviewport(0, 0,639, 479,1);
		 }
		// Affichage de l'image MISS en rouge
		if (Souris_Clic_Gauche_Zone(5,  43, 80,  63) == 1)
		 {
		  setviewport(86, 5, 634, 474,1);
		  clearviewport ();
		  setviewport(0, 0,639, 479,1);			
		  BoutonInverse(5,  43, 80,  63, "ROUGE");
		  delay (200);
		  Bouton(5,  43, 80,  63, "ROUGE");
		  getpalette (&palette);
		  for (i = 0; i <= palette.size-1; i++ )
			 setrgbpalette (palette.colors[i],4*i,0, 0);
		  setviewport(234, 111,490, 367,1);
		  Affiche_Image (ImageMiss, 0, 255, 0, 255, ROUGE);
		  setviewport(0, 0,639, 479,1);
		 }
		// Affichage de l'image MISS en vert
		if (Souris_Clic_Gauche_Zone(5, 66, 80, 86) == 1)
		 {
		  setviewport(86, 5, 634, 474,1);
		  clearviewport ();
		  setviewport(0, 0,639, 479,1);			
		  BoutonInverse(5, 66, 80, 86, "VERT");
		  delay (200);
		  Bouton(5, 66, 80, 86, "VERT");
		  getpalette (&palette);
		  for (i = 0; i <= palette.size-1; i++ )
			 setrgbpalette (palette.colors[i], 0,4*i,0);
		  setviewport(234, 111,490, 367,1);
		  Affiche_Image (ImageMiss, 0, 255, 0, 255, VERT);
		  setviewport(0, 0,639, 479,1);
		 }
		// Affichage de l'image MISS en bleu
		if (Souris_Clic_Gauche_Zone(5, 89, 80, 109) == 1)
		 {
		  setviewport(86, 5, 634, 474,1);
		  clearviewport ();
		  setviewport(0, 0,639, 479,1);			
		  BoutonInverse(5, 89, 80, 109, "BLEU");
		  delay (200);
		  Bouton(5, 89, 80, 109, "BLEU");
		  getpalette (&palette);
		  for (i = 0; i <= palette.size-1; i++ )
			 setrgbpalette (palette.colors[i], 0,0,4*i);
		  setviewport(234, 111,490, 367,1);
		  Affiche_Image (ImageMiss, 0, 255, 0, 255, BLEU);
		  setviewport(0, 0,639, 479,1);
		 }
		// Affichage de l'image MISS en gris
		if (Souris_Clic_Gauche_Zone(5, 112, 80, 132) == 1)
		 {
		  setviewport(86, 5, 634, 474,1);
		  clearviewport ();
		  setviewport(0, 0,639, 479,1);			
		  BoutonInverse(5, 112, 80, 132, "GRIS");
		  delay (200);
		  Bouton(5, 112, 80, 132, "GRIS");
			setviewport(86, 5, 634, 474,1);
			clearviewport ();
		  setviewport(0, 0,639, 479,1);
		  getpalette (&palette);
		  for (i = 0; i <= palette.size-1; i++ )
			 setrgbpalette (palette.colors[i], 4*i,4*i,4*i);
		  setviewport(234, 111,490, 367,1);
		  Affiche_Image (ImageMiss, 0, 255, 0, 255, GRIS);
		  setviewport(0, 0,639, 479,1);
		 }
		  // HISTOGRAMME
		if (Souris_Clic_Gauche_Zone(5, 135, 80, 155 ) == 1)
		  {
			Histogramme = f3tensor(0L, 4L, 0L, 256L, 0L, 0L);
			BoutonInverse(5, 135, 80, 155, "HISTOGRAMME");
			delay (200);
			Bouton(5, 135, 80, 155, "HISTOGRAMME");
			setviewport(86, 5, 634, 474,1);
			clearviewport ();
			setviewport(0, 0,639, 479,1);
			Palette_Systeme();
			Histogramme_Image(ImageMiss,Histogramme,ROUGE, 0, 255, 0, 255, 90, 10, 630,100, LIGHTRED);
			Histogramme_Image(ImageMiss,Histogramme,VERT, 0, 255, 0, 255, 90, 110, 630,200, LIGHTGREEN);
			Histogramme_Image(ImageMiss,Histogramme,BLEU, 0, 255, 0, 255, 90, 210, 630,300, LIGHTBLUE);
			Histogramme_Image(ImageMiss,Histogramme,GRIS, 0, 255, 0, 255, 90, 310, 630,470, LIGHTGRAY);
			setviewport(0, 0,639, 479,1);
			free_f3tensor(Histogramme,0L, 2L, 0L, 256L,0L,1L);
		  }
		//EFFACER
		if (Souris_Clic_Gauche_Zone(5, 158, 80, 178 ) == 1)
		  {
			Souris_Cache();			 
			BoutonInverse(5, 158, 80, 178, "EFFACER");
			Souris_Affichage ();			  			
			delay (200);
			Souris_Cache();			 			
			Bouton(5, 158, 80, 178, "EFFACER");
			Souris_Affichage ();			  						
			setviewport(86, 5, 634, 474,1);
			clearviewport ();
			setviewport(0, 0,639, 479,1);
			Palette_Systeme();
		  }	
		//PALETTE CLIC GAUCHE
		if (Souris_Clic_Gauche_Zone(5, 181, 80, 201 ) == 1)
		  {
			if (affichagepetitepalette == 0)
			 {
			  Souris_Cache();			 
			  BoutonInverse(5, 181, 80, 201, "PALETTE");
			  Souris_Affichage ();			  
			  Affiche_Palette (5, 400, 80, 475);
			  affichagepetitepalette = 1;
			  delay (300);
			 } 
			else 
			 {
			  Souris_Cache();
			  Bouton(5, 181, 80, 201, "PALETTE");
			  Souris_Affichage ();
			  setfillstyle (SOLID_FILL, LIGHTGRAY);
			  bar(5, 400, 80, 475);	 	 	 	 
			  affichagepetitepalette = 0;
			  delay (300);
			 }
		  }
		//PALETTE CLIC DROIT
		if (Souris_Clic_Droit_Zone(5, 181, 80, 201 ) == 1)
		  {
			if (affichagegrandepalette == 0)
			 {
			  Souris_Cache();			 
			  BoutonInverse(5, 181, 80, 201, "PALETTE");
			  Affiche_Palette (86, 5, 634, 474); 
			  Souris_Affichage ();			  
			  affichagegrandepalette = 1;
			  delay (300);
			 } 
			else 
			 {
			  Souris_Cache();
			  Bouton(5, 181, 80, 201, "PALETTE");
			  Souris_Affichage ();
			  setfillstyle (SOLID_FILL, BLACK);
			  bar(86, 5, 634, 474);	 	 	 	 
			  affichagegrandepalette = 0;
			  delay (300);
			 }
		  }

		//QUITTER
		if (Souris_Clic_Gauche_Zone(5, 204, 80, 224 ) == 1)
		  {
			BoutonInverse(5, 204, 80, 224, "QUITTER");
			delay (200);
			Bouton(5, 204, 80, 224, "QUITTER");
			delay (200);
			reponse = 'Q';
		  }
	  }
	 while (reponse != 'Q');
	 free_f3tensor(FO, 0, 15,0, 15, 0, 15);
	 Liberation_Tenseur_UC(ImageMiss,4, 0, 255, 0, 255);
	 closegraph();
	 exit (1);
 }
//****************************************************************************************************************
//****************************************************************************************************************

//--------------------------------------------------------------
// DECIMAL CODE SUR 8 BITS -> DECIMAL CODE SUR 4 BITS
//--------------------------------------------------------------
// Entre : nombre decimal
//          Adresse du tableau de bits
// Sortie : void
//--------------------------------------------------------------
short Conversion(short n)
 {
  short reste, quotient, i, tableau_8bits[8], resultat;

  for (i = 7; i >= 0; i --)
	{
	 quotient = n / 2;
	 reste = n % 2;
	 tableau_8bits[i] = reste;
	 n = quotient;
	}
  resultat = 0;
  for (i = 0; i < 4; i ++)
	{
	 resultat += tableau_8bits[i]*pow((double)2, (double)(3-i));
	}
  return (resultat);
 }


//--------------------------------------------------------------
// RESERVATION MEMOIRE POUR UN TENSEUR D'UNSIGNED CHAR
//--------------------------------------------------------------
// Entres : Nombre de plans (ou de couleurs pour une image)
//           Indice de dbut de ligne
//           Indice de fin de ligne
//           Indice de dbut de colonne
//           Indice de fin de colonne
// Sortie :  Pointeur sur le tenseur d'unsigned char
//--------------------------------------------------------------
unsigned char ***Reservation_Tenseur_UC  (long nbplan,
														long Debut_Ligne,
														long Fin_Ligne,
														long Debut_Colonne,
														long Fin_Colonne)
{
 long plan,i;
 unsigned char ***tenseur;

 tenseur = (unsigned char ***)malloc(nbplan * sizeof(unsigned char **));
 if (tenseur == NULL)
  {
	printf("\a\nProblme d'allocation mmoire 1");
	return(NULL);
  }


 for ( plan = 0; plan < nbplan; plan++)
  {
	tenseur[plan]=(unsigned char **)malloc((unsigned)(Fin_Ligne-Debut_Ligne+1)*sizeof(unsigned char *));
	if (tenseur[plan] == NULL)
	 {
	  printf("\a\nProblme d'allocation mmoire 2");
	  return(NULL);
	 }
	tenseur[plan] -= Debut_Ligne;
	for ( i = Debut_Ligne; i <= Fin_Ligne; i++)
	 {
	  tenseur[plan][i]=(unsigned char *)malloc((unsigned)(Fin_Colonne-Debut_Colonne+1)*sizeof(unsigned char));
	  if ( tenseur[plan][i] == NULL )
		{
		 printf("\a\nProblme d'allocation mmoire 3");
		 return(NULL);
		}
	  tenseur[plan][i] -= Debut_Colonne;
	 }
  }
 return(tenseur);
}

//--------------------------------------------------------------
// RESERVATION MEMOIRE POUR UN TENSEUR DE FLOAT
//--------------------------------------------------------------
// Entres : Nombre de plans (ou de composantes de couleurs pour une image)
//           Indice de dbut de ligne
//           Indice de fin de ligne
//           Indice de dbut de colonne
//           Indice de fin de colonne
// Sortie :  Pointeur sur le tenseur de float
//--------------------------------------------------------------
float ***Reservation_Tenseur_FLOAT (long nbplan,
												long Debut_Ligne,
												long Fin_Ligne,
												long Debut_Colonne,
												long Fin_Colonne)
{
 long plan,i;
 float ***tenseur;

 tenseur = (float ***)malloc(nbplan * sizeof(float **));
 if (tenseur == NULL)
  {
	printf("\a\nProblme d'allocation mmoire 1");
	return(NULL);
  }


 for ( plan = 0; plan < nbplan; plan++)
  {
	tenseur[plan]=(float **)malloc((unsigned)(Fin_Ligne-Debut_Ligne+1)*sizeof(float *));
	if (tenseur[plan] == NULL)
	 {
	  printf("\a\nProblme d'allocation mmoire 2");
	  return(NULL);
	 }
	tenseur[plan] -= Debut_Ligne;
	for ( i = Debut_Ligne; i <= Fin_Ligne; i++)
	 {
	  tenseur[plan][i]=(float *)malloc((unsigned)(Fin_Colonne-Debut_Colonne+1)*sizeof(float));
	  if ( tenseur[plan][i] == NULL )
		{
		 printf("\a\nProblme d'allocation mmoire 3");
		 return(NULL);
		}
	  tenseur[plan][i] -= Debut_Colonne;
	 }
  }
 return(tenseur);
}

//--------------------------------------------------------------
// AFFICHAGE D'UNE IMAGE
//--------------------------------------------------------------
// Entres : Pointeur sur le tenseur image d'unsigned char
//				 Indice de dbut de ligne
//				 Indice de fin de ligne
//				 Indice de dbut de colonne
//				 Indice de fin de colonne
//           Indice de couleur  afficher :
// Sortie : void
//--------------------------------------------------------------
void Affiche_Image(unsigned char ***imageRGB,
						 short debutligne,
						 short finligne,
						 short debutcolonne,
						 short fincolonne,
						 short couleur)
 {
  int i, j;
  int errorcode;
  errorcode = graphresult ();
  if ( errorcode != grOk)
	{
	 printf ("\nErreur graphique : %s", grapherrormsg (errorcode));
	 printf ("\nPressez une touche...\n");
	 return ;
	}
  Souris_Cache ();	
  for (i = debutligne; i < finligne; i++ )
	 for (j = debutcolonne; j < fincolonne; j++ )
		putpixel (i, j, imageRGB[couleur][i][j]/16);
  Souris_Affichage ();		
}

//--------------------------------------------------------------
// LIBERATION MEMOIRE POUR UN TENSEUR D'UNSIGNED CHAR
//--------------------------------------------------------------
// Entres : Pointeur sur le tenseur image d'unsigned char
//           Nombre de plans du tenseur (ou de couleurs)
//				 Indice de dbut de ligne
//				 Indice de fin de ligne
//				 Indice de dbut de colonne
//				 Indice de fin de colonne
// Sortie : void
//--------------------------------------------------------------
void Liberation_Tenseur_UC(unsigned char *** tenseur,
									long nbplan,
									long Debut_Ligne,
									long Fin_Ligne,
									long Debut_Colonne,
									long Fin_Colonne)
 {
  long i,j;
  for (j = nbplan-1; j >= 0; j--)
	{
	 for (i = Fin_Ligne; i >= Debut_Ligne; i--) free((unsigned char *)(tenseur[j][i] + Debut_Colonne));
	 free((unsigned char **)(tenseur[j] + Debut_Ligne));
	}
  free((unsigned char ***)(tenseur + Debut_Ligne));
  Debut_Colonne = Fin_Colonne;// warning
 }


//--------------------------------------------------------------
// CALCULE ET TRACE DE L'HISTOGRAMME D'UNE IMAGE
//--------------------------------------------------------------
// Entres : Pointeur sur le tenseur de l'image  lisser
//           Pointeur sur le tableau d'histogramme
//           Indice de la couleur dont on veut tracer l'histogramme
//				 Indice de dbut de ligne
//				 Indice de fin de ligne
//				 Indice de dbut de colonne
//				 Indice de fin de colonne
//           Gauche de la fentre de trac de l'histogramme
//           Haut de la fentre de trac de l'histogramme
//           Droite de la fentre de trac de l'histogramme
//           Bas de la fentre de trac de l'histogramme
//           Couleur d'affichage
// Sortie : void
//--------------------------------------------------------------
// Histogramme d'une image : Nombre de pixels ayant la mme luminance
// Sur l'axe horizontal : luminance : de 0  255
// Sur l'axe vertical : nombre de pixels de l'image ayant la luminance
// indique sur l'axe horizontal
//--------------------------------------------------------------

void Histogramme_Image(unsigned char ***Image,
							  float *** Histogramme_Image,
							  short couleur,
							  short Debut_Ligne,
							  short Fin_Ligne,
							  short Debut_Colonne,
							  short Fin_Colonne,
							  short gauche,
							  short haut,
							  short droite,
							  short bas,
							  short couleur_affichage)
 {
  short largeur = (droite-gauche), hauteur = (bas-haut), i, j;
  unsigned char pixel;

  setviewport (gauche, haut, droite, bas, 0);
  setfillstyle (SOLID_FILL, couleur_affichage);
  // Initialisation de l'histogramme  0
  for (i = 0; i <= 256; i ++)
	 Histogramme_Image[0][couleur][i] = 0.;
  // Calcul de l'histogramme et recherche du maximum de population
  for (i = Debut_Ligne; i <= Fin_Ligne; i ++)
	 for (j = Debut_Colonne; j <= Fin_Colonne; j ++)
	  {
		pixel = Image[couleur][i][j];
		Histogramme_Image[0][couleur][(short)pixel] ++;
		if (Histogramme_Image[0][couleur][256] <= Histogramme_Image[0][couleur][(short)pixel])
		  Histogramme_Image[0][couleur][256]  = Histogramme_Image[0][couleur][(short)pixel]; // Maximum de population
	  }
  // Trac de l'histogramme
  for (i = 0; i <= 255; i ++)
	 bar (i*(float)largeur/256.,hauteur*(1-(Histogramme_Image[0][couleur][i]/
	 Histogramme_Image[0][couleur][256])),(i+1)*(largeur/256.),hauteur);
 }

//--------------------------------------------------------------
// LIBERATION MEMOIRE POUR UN TENSEUR DE FLOAT
//--------------------------------------------------------------
// Entres : Pointeur sur le tenseur image de float
//           Nombre de plans du tenseur (ou de couleurs)
//				 Indice de dbut de ligne
//				 Indice de fin de ligne
//				 Indice de dbut de colonne
//				 Indice de fin de colonne
// Sortie : void
//--------------------------------------------------------------
void Liberation_Tenseur_FLOAT(float *** tenseur,
										long nbplan,
										long Debut_Ligne,
										long Fin_Ligne,
										long Debut_Colonne,
										long Fin_Colonne)
 {
  long i,j;
  for (j = nbplan-1; j >= 0; j--)
	{
	 for (i = Fin_Ligne; i >= Debut_Ligne; i--) free((float *)(tenseur[j][i] + Debut_Colonne));
	 free((float **)(tenseur[j] + Debut_Ligne));
	}
  free((float ***)(tenseur + Debut_Ligne));
  Debut_Colonne = Fin_Colonne;// (warning)
 }


//--------------------------------------------------------------
// TRI d'un tableau de structures
//--------------------------------------------------------------
// Entres : Dimension du tableau
//           Adresse du tableau de float
// Sortie : void
//--------------------------------------------------------------
void shell(short n,
			  ELEMENT a[])
{
	short i,j,inc;
	ELEMENT v;
	inc=1;
	do
	 {
	  inc *= 3;
	  inc++;
	 }
	while (inc <= n);

	do
	 {
	  inc /= 3;
	  for (i=inc+1;i<=n;i++)
		{
		 v.nombre = a[i].nombre;
		 v.rouge  = a[i].rouge;
		 v.vert   = a[i].vert;
		 v.bleu   = a[i].bleu;
		 j=i;
		 while (a[j-inc].nombre > v.nombre)
		  {
			a[j].nombre=a[j-inc].nombre;
			a[j].rouge=a[j-inc].rouge;
			a[j].vert=a[j-inc].vert;
			a[j].bleu=a[j-inc].bleu;
			j -= inc;
			if (j <= inc) break;
		  }
		 a[j].nombre = v.nombre;
		 a[j].rouge  = v.rouge;
		 a[j].vert   = v.vert;
		 a[j].bleu   = v.bleu;
		}
	 }
	while (inc > 1);
}

//--------------------------------------------------------------
// AFFICHE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Souris_Affichage(void)
 {
  pregs.x.ax = 1;
  int86(0x33,&pregs,&pregs);
 }

//--------------------------------------------------------------
// CACHE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Souris_Cache(void)
 {
  pregs.x.ax = 2;
  int86(0x33,&pregs,&pregs);
 }
//--------------------------------------------------------------
// DEFINIT LE CURSEUR DE LA SOURIS
//--------------------------------------------------------------
// Entre : Chane de caractre
// Sortie : void
//--------------------------------------------------------------

void  Souris_Definition_Curseur(char curseur)
 {
  short croix[64] = {0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,     0,
							0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,0xfeff,
							0x100,  0x100, 0x100, 0x100, 0x100, 0x100, 0x100,0xffff,
							0x100,  0x100, 0x100, 0x100, 0x100, 0x100, 0x100, 0x100,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff};
  short index[64] = {0x9fff,0x6fff,0x6fff,0x6fff,0x6fff,0x6249,0x6db6,0x6db6,
							0x6db6,0x6db6,0x7ffe,0x7ffe,0xbffd,0xbffd,0xbffd,0x8003,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
							0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff};					
  pregs.x.ax = 0x9;             
  if (curseur == 'c')
	{
	 pregs.x.bx = 7;
	 pregs.x.cx = 8;
	 pregs.x.dx = (unsigned int)croix;
	} 
  if (curseur == 'i')
	{
	 pregs.x.bx = 0;
	 pregs.x.cx = 0;
	 pregs.x.dx = (unsigned int)index;
	} 
  int86(0x33,&pregs,&pregs);
 }

//--------------------------------------------------------------
// DEPLACE LA SOURIS
//--------------------------------------------------------------
// Entres : Dplacement horizontal en pixel
//           Dplacement vertical en pixel
// Sortie : void
//--------------------------------------------------------------
void Souris_Deplacement(short Horizontal,
								short Vertical)
 {
  pregs.x.ax = 4;
  pregs.x.cx = Horizontal;
  pregs.x.dx = Vertical;
  int86(0x33,&pregs,&pregs);
 }
//--------------------------------------------------------------
// RENVOIT LA POSITION HORIZONTALE DE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  position horizontale
//--------------------------------------------------------------
short xsouris(void)
 {
  pregs.x.ax = 4;
  int86(0x33,&pregs,&pregs);
  return (pregs.x.cx);
 }
//--------------------------------------------------------------
// RENVOIT LA POSITION VERTICALE DE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  position verticale
//--------------------------------------------------------------
short ysouris(void)
 {
  pregs.x.ax = 4;
  int86(0x33,&pregs,&pregs);
  return (pregs.x.dx);
 }

//--------------------------------------------------------------
// LIMITE LA ZONE DE MOBILITE DE LA SOURIS
//--------------------------------------------------------------
// Entre : gauche
//				haut
//				droite
//          bas
// Sortie : void
//--------------------------------------------------------------
void Souris_Limite(short gauche,
						 short haut,
						 short droite,
						 short bas)
 {
  pregs.x.ax = 7;
  pregs.x.cx = gauche;
  pregs.x.dx = droite; 
  int86(0x33,&pregs,&pregs);
  pregs.x.ax = 8;
  pregs.x.cx = haut;
  pregs.x.dx = bas; 
  int86(0x33,&pregs,&pregs);
 }
//--------------------------------------------------------------
// DEFINIT UNE ZONE D'EXCLUSION DE LA SOURIS
//--------------------------------------------------------------
// Entre : gauche
//				haut
//				droite
//          bas
// Sortie : void
//--------------------------------------------------------------

void  Souris_Exclusion(short gauche,
							  short haut,
							  short droite,
							  short bas)
 {
  pregs.x.ax = 0x10;
  pregs.x.cx = gauche;
  pregs.x.dx = droite; 
  pregs.x.si = haut;
  pregs.x.di = bas; 
  int86(0x33,&pregs,&pregs);
 }

//--------------------------------------------------------------
// DETECTE UN CLIC GAUCHE DE SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  1 : Si le bouton gauche a t press
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic(void)
 {
  pregs.x.ax = 3;
  int86(0x33,&pregs,&pregs);
  if (pregs.x.bx == 1)
	 return(1);
  else
	 return(0);
 }


//--------------------------------------------------------------
// DETECTE UN CLIC GAUCHE DE SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie :  1 : Si la souris est dans la zone ET si le bouton
//               gauche a t press dans cette zone.
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Gauche_Zone(short gauche,
							  short haut,
							  short droite,
							  short bas)
 {
  pregs.x.ax = 3;
  int86(0x33,&pregs,&pregs);

  if  ((pregs.x.bx == 1)       &&
		 (pregs.x.cx >= gauche)  &&
		 (pregs.x.cx <= droite)  &&
		 (pregs.x.dx >= haut  )  &&
		 (pregs.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }

//--------------------------------------------------------------
// DETECTE UN CLIC DROIT DE SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie :  1 : Si la souris est dans la zone ET si le bouton
//               gauche a t press dans cette zone.
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Droit_Zone(short gauche,
							  short haut,
							  short droite,
							  short bas)
 {
  pregs.x.ax = 3;
  int86(0x33,&pregs,&pregs);

  if  ((pregs.x.bx == 2)       &&
		 (pregs.x.cx >= gauche)  &&
		 (pregs.x.cx <= droite)  &&
		 (pregs.x.dx >= haut  )  &&
		 (pregs.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }

//--------------------------------------------------------------
// DETECTE LA POSITION DE LA SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie : 1 : Si la souris est dans la zone
//          0 : Sinon
//--------------------------------------------------------------
short Souris_Zone(short gauche,
						short haut,
						short droite,
						short bas)
 {
  pregs.x.ax = 3;
  int86(0x33,&pregs,&pregs);

  if  ((pregs.x.cx >= gauche)  &&
		 (pregs.x.cx <= droite)  &&
		 (pregs.x.dx >= haut  )  &&
		 (pregs.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }

//--------------------------------------------------------------
// BOUTON DE COMMANDE
//--------------------------------------------------------------
// Entres : Coordonnes du bouton : gauche, haut, droite, bas
//           Texte du bouton
// Sortie : void
//--------------------------------------------------------------
void Bouton(short gauche,
				short haut,
				short droite,
				short bas,
				char Texte[20])
 {
  setfillstyle (SOLID_FILL, LIGHTGRAY);
  bar (gauche, haut, droite ,bas);
  settextstyle(SMALL_FONT, HORIZ_DIR, 0);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  setcolor (BLACK);
  outtextxy (gauche + (droite-gauche)/2, haut + (bas-haut)/2, Texte);
  setcolor (DARKGRAY);
  line (droite, haut, droite, bas);
  line (gauche, bas, droite, bas);
  setcolor (WHITE);
  line (gauche, haut, gauche, bas);
  line (gauche, haut, droite, haut);
 }

//--------------------------------------------------------------
// BOUTON DE COMMANDE APPUYE
//--------------------------------------------------------------
// Entres : Coordonnes du bouton
//           Texte du bouton
// Sortie : void
//--------------------------------------------------------------
void BoutonInverse(short gauche,
						 short haut,
						 short droite,
						 short bas,
						 char Texte[20])
 {
  setfillstyle (SOLID_FILL, LIGHTGRAY);
  bar (gauche, haut, droite ,bas);
  settextstyle(SMALL_FONT, HORIZ_DIR, 0);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  setcolor (BLACK);
  outtextxy (gauche + (droite-gauche)/2+1, haut + (bas-haut)/2+1 , Texte);
  setcolor (DARKGRAY);
  line (gauche, haut, gauche, bas);
  line (gauche, haut, droite, haut);
  setcolor (WHITE);
  line (droite, haut, droite, bas);
  line (gauche, bas, droite, bas);
 }

/* allocate a float 3tensor with range t[nrl..nrh][ncl..nch][ndl..ndh] */
float ***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh)
{
	long i,j,nrow=nrh-nrl+1,ncol=nch-ncl+1,ndep=ndh-ndl+1;
	float ***t;

	/* allocate pointers to pointers to rows */
	t=(float ***) malloc((size_t)((nrow+1)*sizeof(float**)));
	if (!t) printf("allocation failure 1 in f3tensor()");
	t += 1;
	t -= nrl;

	/* allocate pointers to rows and set pointers to them */
	t[nrl]=(float **) malloc((size_t)((nrow*ncol+1)*sizeof(float*)));
	if (!t[nrl]) printf("allocation failure 2 in f3tensor()");
	t[nrl] += 1;
	t[nrl] -= ncl;

	/* allocate rows and set pointers to them */
	t[nrl][ncl]=(float *) malloc((size_t)((nrow*ncol*ndep+1)*sizeof(float)));
	if (!t[nrl][ncl]) printf("allocation failure 3 in f3tensor()");
	t[nrl][ncl] += 1;
	t[nrl][ncl] -= ndl;

	for(j=ncl+1;j<=nch;j++) t[nrl][j]=t[nrl][j-1]+ndep;
	for(i=nrl+1;i<=nrh;i++) {
		t[i]=t[i-1]+ncol;
		t[i][ncl]=t[i-1][ncl]+ncol*ndep;
		for(j=ncl+1;j<=nch;j++) t[i][j]=t[i][j-1]+ndep;
	}

	/* return pointer to array of pointers to rows */
	return t;
}

/* free a float f3tensor allocated by f3tensor() */
void free_f3tensor(float ***t, long nrl, long nrh, long ncl, long nch,long ndl, long ndh)
 {
  free((char *) (t[nrl][ncl]+ndl-1));
  free((char *) (t[nrl]+ncl-1));
  free((char *) (t+nrl-1));
  nrl = nrh;
  nrl = nch;
  nrl = ndh;	
 }

//--------------------------------------------------------------
// AFFICHE LA PALETTE
//--------------------------------------------------------------
// Entres : coordonnes de la fentre d'affichage
// Sortie : void
//--------------------------------------------------------------
void Affiche_Palette(short gauche, 
							short haut, 
							short droite, 
							short bas)
 {                    
  short i,j,c=0;
  setfillstyle (SOLID_FILL, LIGHTGRAY);
  bar (gauche, haut, droite, bas);
  gauche += 3; droite -= 3; haut += 3; bas -= 3;
  for (j = 0; j < 4; j ++)
	 for (i = 0; i < 4; i ++)
	  {
		setfillstyle (SOLID_FILL,c++);
		bar(2+gauche+j*(droite-gauche)/4, 2+haut+i*(bas-haut)/4, -2+gauche+(j+1)*(droite-gauche)/4,-2+haut+(i+1)*(bas-haut)/4);
		setcolor(BLACK);
		line (1+gauche+j*(droite-gauche)/4, 1+haut+i*(bas-haut)/4, gauche-1+(j+1)*(droite-gauche)/4,1+haut+i*(bas-haut)/4);// haut
		line (1+gauche+j*(droite-gauche)/4, 1+haut+i*(bas-haut)/4, 1+gauche+j*(droite-gauche)/4,haut-1+(i+1)*(bas-haut)/4);
		setcolor(WHITE);
		line (1+gauche+j*(droite-gauche)/4, -1+haut+(i+1)*(bas-haut)/4, -1+gauche+(j+1)*(droite-gauche)/4,-1+haut+(i+1)*(bas-haut)/4);// haut
		line (-1+gauche+(j+1)*(droite-gauche)/4, 1+haut+i*(bas-haut)/4, -1+gauche+(j+1)*(droite-gauche)/4,haut-1+(i+1)*(bas-haut)/4);
	  } 
 }							  
//--------------------------------------------------------------
// RESTAURE LA PALETTE SYSTEME
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Palette_Systeme(void)
 {
  setrgbpalette(palette.colors[ 0],  0,  0,  0);
  setrgbpalette(palette.colors[ 1],  0,  0, 32);
  setrgbpalette(palette.colors[ 2],  0, 32,  0);
  setrgbpalette(palette.colors[ 3],  0, 32, 32);
  setrgbpalette(palette.colors[ 4], 32,  0,  0);
  setrgbpalette(palette.colors[ 5], 32,  0, 32);
  setrgbpalette(palette.colors[ 6], 32, 32,  0);
  setrgbpalette(palette.colors[ 7], 45, 45, 45);
  setrgbpalette(palette.colors[ 8], 32, 32, 32);
  setrgbpalette(palette.colors[ 9],  0,  0, 63);
  setrgbpalette(palette.colors[10],  0, 63,  0);
  setrgbpalette(palette.colors[11],  0, 63, 63);
  setrgbpalette(palette.colors[12], 63,  0,  0);
  setrgbpalette(palette.colors[13], 63,  0, 63);
  setrgbpalette(palette.colors[14], 63, 63,  0);
  setrgbpalette(palette.colors[15], 63, 63, 63);
 }
 

 
