//**************************************************************
//                   Gestion de la souris                      *
//**************************************************************

#define FLECHE       0
#define CROIXOBLIQUE 1
#define INDEX        2
#define SABLIER      3
#define CROIX        4
// Prototypes gestion de la souris
  void  Souris_Initialisation    (void);
  void  Souris_Cache             (void);
  void  Souris_Affichage         (void);
  short Souris_Clic_Gauche       (void);
  short Souris_Clic_Droit        (void);  
  short xsouris                  (void);
  short ysouris                  (void);  
  void  Souris_Deplacement       (short, short);
  short Souris_Zone              (short, short, short, short);
  short Souris_Clic_Gauche_Zone  (short, short, short, short);
  short Souris_Clic_Droit_Zone   (short, short, short, short);
  void  Souris_Limite            (short, short, short, short);
  void  Souris_Exclusion         (short, short, short, short);
  void  Souris_Definition_Curseur(short, short, short);    
// Interface
  void BoutonInverse(short ,short, short, short, char [20]);
  void Bouton       (short ,short, short, short, char [20]);
  void Palette_Systeme ();

//--------------------------------------------------------------
// INITIALISATION DE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Souris_Initialisation(void)
 {
  union REGS registre;
  registre.x.ax = 0;
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// AFFICHE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Souris_Affichage(void)
 {
  union REGS registre; 
  registre.x.ax = 1;
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// CACHE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Souris_Cache(void)
 {
  union REGS registre; 
  registre.x.ax = 2;
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// DEFINIT LE CURSEUR DE LA SOURIS
//--------------------------------------------------------------
// Entre : entier reprant le curseur
//          distance du point de pointage horizontal
//          distance du point de pointage vertical
// Sortie : void
//--------------------------------------------------------------
void  Souris_Definition_Curseur(short curseur,short x, short y)
 {
  union REGS registre; 
short croix[64] = {
	 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0x0001,
	 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xfeff, 0xffff,
	 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0xfffe,
	 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0000,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x1556 };
short croixoblique[64] = {
	 0xffff, 0xffff, 0xdffb, 0xeff7, 0xf7ef, 0xfbdf, 0xfdbf, 0xfe7f,
	 0xfe7f, 0xfdbf, 0xfbdf, 0xf7ef, 0xeff7, 0xdffb, 0xffff, 0xffff,
	 0x0000, 0x0000, 0x2004, 0x1008, 0x0810, 0x0420, 0x0240, 0x0180,
	 0x0180, 0x0240, 0x0420, 0x0810, 0x1008, 0x2004, 0x0000, 0x0000,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x13ca };
short index[64] = {
	 0x9fff, 0x6fff, 0x6fff, 0x6fff, 0x6fff, 0x6fff, 0x6fff, 0x624f,
	 0x6db7, 0x6db7, 0x6db7, 0x7db7, 0x7ff7, 0x7ff7, 0x7ff7, 0x800f,
	 0x6000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9db0,
	 0x9248, 0x9248, 0x9248, 0x8248, 0x8008, 0x8008, 0x8008, 0x7ff0,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x1556 };  
short sablier[64] = {
	 0xf800, 0xfbfe, 0xfbfe, 0xfdfd, 0xfe03, 0xff07, 0xff8f, 0xffdf,
	 0xff8f, 0xff57, 0xfedb, 0xfddd, 0xfb8e, 0xf800, 0xf800, 0xffff,
	 0x07ff, 0x0401, 0x0401, 0x0202, 0x01fc, 0x00f8, 0x0070, 0x0020,
	 0x0070, 0x00a8, 0x0124, 0x0222, 0x0471, 0x07ff, 0x07ff, 0x0000,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x1406 };
short fleche[64] = {
	 0x7fff, 0x3fff, 0x1fff, 0x0fff, 0x07ff, 0x03ff, 0x01ff, 0x03ff,
	 0x07ff, 0x07ff, 0x07ff, 0x63ff, 0xf1ff, 0xf9ff, 0xf8ff, 0xfcff,
	 0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xfc00,
	 0xf800, 0xf800, 0xf800, 0x9c00, 0x0e00, 0x0600, 0x0700, 0x0300,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x1596 };	 	 
  registre.x.ax = 0x9;
  registre.x.bx = x;
  registre.x.cx = y;
  switch (curseur)
	{
	 case FLECHE:
		registre.x.dx = (unsigned int)fleche;
		break;
	 case CROIX: 
		registre.x.dx = (unsigned int)croix;
		break;
	 case CROIXOBLIQUE: 
		registre.x.dx = (unsigned int)croixoblique;
		break;
	 case INDEX: 
		registre.x.dx = (unsigned int)index;
		break;
	 case SABLIER: 
		registre.x.dx = (unsigned int) sablier;
	}	
  int86(0x33,&registre,&registre);
 }

//--------------------------------------------------------------
// DEPLACE LA SOURIS
//--------------------------------------------------------------
// Entres : Dplacement horizontal en pixel
//           Dplacement vertical en pixel
// Sortie : void
//--------------------------------------------------------------
void Souris_Deplacement(short Horizontal,
								short Vertical)
 {
  union REGS registre; 
  registre.x.ax = 4;
  registre.x.cx = Horizontal;
  registre.x.dx = Vertical;
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// RENVOIT LA POSITION HORIZONTALE DE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  position horizontale
//--------------------------------------------------------------
short xsouris(void)
 {
  union REGS registre; 
  registre.x.ax = 4;
  int86(0x33,&registre,&registre);
  return (registre.x.cx);
 }
//--------------------------------------------------------------
// RENVOIT LA POSITION VERTICALE DE LA SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  position verticale
//--------------------------------------------------------------
short ysouris(void)
 {
  union REGS registre; 
  registre.x.ax = 4;
  int86(0x33,&registre,&registre);
  return (registre.x.dx);
 }
//--------------------------------------------------------------
// LIMITE LA ZONE DE MOBILITE DE LA SOURIS
//--------------------------------------------------------------
// Entre : gauche
//				haut
//				droite
//          bas
// Sortie : void
//--------------------------------------------------------------
void Souris_Limite(short gauche,
						 short haut,
						 short droite,
						 short bas)
 {
  union REGS registre; 
  registre.x.ax = 7;
  registre.x.cx = gauche;
  registre.x.dx = droite; 
  int86(0x33,&registre,&registre);
  registre.x.ax = 8;
  registre.x.cx = haut;
  registre.x.dx = bas; 
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// DEFINIT UNE ZONE D'EXCLUSION DE LA SOURIS
//--------------------------------------------------------------
// Entre : gauche
//				haut
//				droite
//          bas
// Sortie : void
//--------------------------------------------------------------

void  Souris_Exclusion(short gauche,
							  short haut,
							  short droite,
							  short bas)
 {
  union REGS registre; 
  registre.x.ax = 0x10;
  registre.x.cx = gauche;
  registre.x.dx = droite; 
  registre.x.si = haut;
  registre.x.di = bas; 
  int86(0x33,&registre,&registre);
 }
//--------------------------------------------------------------
// DETECTE UN CLIC GAUCHE DE SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  1 : Si le bouton gauche a t press
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Gauche(void)
 {
  union REGS registre; 
  registre.x.ax = 3;
  int86(0x33,&registre,&registre);
  if (registre.x.bx == 1)
	 return(1);
  else
	 return(0);
 }
//--------------------------------------------------------------
// DETECTE UN CLIC DROIT DE SOURIS
//--------------------------------------------------------------
// Entre : void
// Sortie :  1 : Si le bouton gauche a t press
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Droit(void)
 {
  union REGS registre; 
  registre.x.ax = 3;
  int86(0x33,&registre,&registre);
  if (registre.x.bx == 2)
	 return(1);
  else
	 return(0);
 }
//--------------------------------------------------------------
// DETECTE UN CLIC GAUCHE DE SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie :  1 : Si la souris est dans la zone ET si le bouton
//               gauche a t press dans cette zone.
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Gauche_Zone(short gauche,
										short haut,
										short droite,
										short bas)
 {
  union REGS registre; 
  registre.x.ax = 3;
  int86(0x33,&registre,&registre);
  if  ((registre.x.bx == 1)       &&
		 (registre.x.cx >= gauche)  &&
		 (registre.x.cx <= droite)  &&
		 (registre.x.dx >= haut  )  &&
		 (registre.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }
//--------------------------------------------------------------
// DETECTE UN CLIC DROIT DE SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie :  1 : Si la souris est dans la zone ET si le bouton
//               gauche a t press dans cette zone.
//           0 : Sinon
//--------------------------------------------------------------
short Souris_Clic_Droit_Zone(short gauche,
									  short haut,
									  short droite,
									  short bas)
 {
  union REGS registre; 
  registre.x.ax = 3;
  int86(0x33,&registre,&registre);
  if  ((registre.x.bx == 2)       &&
		 (registre.x.cx >= gauche)  &&
		 (registre.x.cx <= droite)  &&
		 (registre.x.dx >= haut  )  &&
		 (registre.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }
//--------------------------------------------------------------
// DETECTE LA POSITION DE LA SOURIS DANS UNE ZONE RECTANGULAIRE
//--------------------------------------------------------------
// Entres : Coordonnes de la zone : gauche, haut, droite, bas
// Sortie : 1 : Si la souris est dans la zone
//          0 : Sinon
//--------------------------------------------------------------
short Souris_Zone(short gauche,
						short haut,
						short droite,
						short bas)
 {
  union REGS registre; 
  registre.x.ax = 3;
  int86(0x33,&registre,&registre);
  if  ((registre.x.cx >= gauche)  &&
		 (registre.x.cx <= droite)  &&
		 (registre.x.dx >= haut  )  &&
		 (registre.x.dx <= bas   ))
	 return(1);
  else
	 return(0);
 }
//--------------------------------------------------------------
// BOUTON DE COMMANDE
//--------------------------------------------------------------
// Entres : Coordonnes du bouton : gauche, haut, droite, bas
//           Texte du bouton
// Sortie : void
//--------------------------------------------------------------
void Bouton(short gauche,
				short haut,
				short droite,
				short bas,
				char Texte[20])
 {
  setfillstyle (SOLID_FILL, LIGHTGRAY);
  bar (gauche, haut, droite ,bas);
  settextstyle(SMALL_FONT, HORIZ_DIR, 0);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  setcolor (BLACK);
  outtextxy (gauche + (droite-gauche)/2, haut + (bas-haut)/2, Texte);
  setcolor (DARKGRAY);
  line (droite, haut, droite, bas);
  line (gauche, bas, droite, bas);
  setcolor (WHITE);
  line (gauche, haut, gauche, bas);
  line (gauche, haut, droite, haut);
 }
//--------------------------------------------------------------
// BOUTON DE COMMANDE APPUYE
//--------------------------------------------------------------
// Entres : Coordonnes du bouton
//           Texte du bouton
// Sortie : void
//--------------------------------------------------------------
void BoutonInverse(short gauche,
						 short haut,
						 short droite,
						 short bas,
						 char Texte[20])
 {
  setfillstyle (SOLID_FILL, LIGHTGRAY);
  bar (gauche, haut, droite ,bas);
  settextstyle(SMALL_FONT, HORIZ_DIR, 0);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  setcolor (BLACK);
  outtextxy (gauche + (droite-gauche)/2+1, haut + (bas-haut)/2+1 , Texte);
  setcolor (DARKGRAY);
  line (gauche, haut, gauche, bas);
  line (gauche, haut, droite, haut);
  setcolor (WHITE);
  line (droite, haut, droite, bas);
  line (gauche, bas, droite, bas);
 }
//--------------------------------------------------------------
// RESTAURE LA PALETTE SYSTEME
//--------------------------------------------------------------
// Entre : void
// Sortie : void
//--------------------------------------------------------------
void Palette_Systeme(void)
 {
  struct palettetype palette;
  getpalette(&palette);
  setrgbpalette(palette.colors[ 0],  0,  0,  0);// BLACK
  setrgbpalette(palette.colors[ 1],  0,  0, 32);// BLUE
  setrgbpalette(palette.colors[ 2],  0, 32,  0);// GREEN
  setrgbpalette(palette.colors[ 3],  0, 32, 32);
  setrgbpalette(palette.colors[ 4], 32,  0,  0);
  setrgbpalette(palette.colors[ 5], 32,  0, 32);
  setrgbpalette(palette.colors[ 6], 32, 32,  0);
  setrgbpalette(palette.colors[ 7], 45, 45, 45);
  setrgbpalette(palette.colors[ 8], 32, 32, 32);
  setrgbpalette(palette.colors[ 9],  0,  0, 63);
  setrgbpalette(palette.colors[10],  0, 63,  0);
  setrgbpalette(palette.colors[11],  0, 63, 63);
  setrgbpalette(palette.colors[12], 63,  0,  0);
  setrgbpalette(palette.colors[13], 63,  0, 63);
  setrgbpalette(palette.colors[14], 63, 63,  0);
  setrgbpalette(palette.colors[15], 63, 63, 63);
 }
 



