#ifndef CRC32_H
#define CRC32_H


//////////////////////////////////////////////////////////////////////
// Cette classe calcule un CRC de 32 bits (donc dans un unsigned long).
// Les dtails du calcul m'chappent et m'intressent peu (valeur du
// masque, des coefficients de polynmes, etc). J'ai trouv tout cela
// dans la littrature (peut-tre bien dans "La compression de donnes"
// de Mark Nelson), en C, et l'ai simplement mis  la "sauce" C++ :
//
// - valeur (char) calcule le crc pour 1 caractre ;
// - valeur(char *, unsigned) calcule le crc pour un tampon d'octets
//   de longueur passe en argument 2 ;
// - valeur() renvoie la valeur du dernier crc calcul ;
// - raz() rinitialise la valeur de crc dtenue.
//////////////////////////////////////////////////////////////////////


///////////
class CRC32 {
///////////
public :
typedef	unsigned long	crc ;		// alias plus parlant

								CRC32		() ;	// constructeur public

			crc				valeur	( unsigned char c )	;
			crc				valeur	( const unsigned char *, unsigned ) ;
			crc				valeur	()	const	{ return CRC ; }
			void				raz		()			{ CRC = MASQUE ; }

private :

static	crc				TABLE[ 256 ] ;	// coefficients mystrieux (pour moi)
static	unsigned char	TABLE_OK ;     // table dj construite
static	crc				MASQUE ;
static	crc				POLYNOME ;
			crc				CRC ;          // dernier crc calcul

static	void				construireTable() ;

} ;


inline CRC32::crc CRC32::valeur( unsigned char c )
//
// Formule reprise dans la littrature...
{
	return ( ( CRC >> 8 ) & 0x00FFFFFF ) ^ TABLE[ 0xFF & ( ( unsigned int )CRC ^ ( unsigned int )c ) ] ;
}


#endif
