/////////////////////////////////////////////////////////////////////////
// Programme principal de dcompression.
// Il n'y a rien d'intressant ici, si ce n'est l'analyse des arguments
// et l'appel de la fonction de dcompression  laquelle on les transmet.
/////////////////////////////////////////////////////////////////////////

#include "lzw.h"
#include <fstream.h>
#include <string.h>
#include <dir.h>

#define NBITS			13	// nous viderons le dico  saturation du code de 13 bits
#define PETIT_NOM    "dcompr"
#define GRAND_NOM		"Dcompression"

#include "traite.inc"	// fichier inclu (jouant le rle d'un .cpp, pas .h)
								// servant  paramtrer (rendre trs semblables) les
								// traitements de compression et de dcompression


// compr_ou_dcompr est une variable de type LZW_membre
// dfini dans traite.inc ; c'est donc un pointeur sur
// la fonction de compression, membre de la classe LZW

LZW_membre	compr_ou_dcompr = &LZW::decompresse ;


int main( int argc, char * argv[] )
{
	// Analyse des arguments de la ligne de commande.
	//
	// Deux formes sont permises :
	//
	// - dcompr source cible	dcomprime source vers cible
	// - dcompr @ordres        un fichier de commandes comprenant une succes-
	//									sion de lignes analogues au cas prcdent :
	//									source1 cible1
	//									source2 cible2
	//									...
	// NB : usage() est une fonction dfinie dans traite.inc : elle affiche
	// en sortie standard les rgles d'utilisation nonces ci-dessus.
	//
	// Comme d'habitude, main renvoie un int qui est exploitable en tant que
	// que errorcode dans un fichier batch sous MsDos.

	switch( argc )	// selon le nombre d'arguments (argc-1)
	{
		// 2 arguments : ne doivent pas commencer par @
		case 3	:	if( argv[ 1 ][ 0 ] == '@' || argv[ 2 ][ 0 ] == '@' )
						{
							usage() ;	return 1 ;
						}
						return traite_un( compr_ou_dcompr, argv[ 1 ], argv[ 2 ] ) ;

		// 1 argument : doit commencer par @ (fichier d'ordres)
		case 2	:  if( argv[ 1 ][ 0 ] != '@' )
						{
							usage() ;	return 1 ;
						}
						return traite_plusieurs( compr_ou_dcompr, argv[ 1 ] ) ;

		// tout autre nombre d'arguments est erron
		case 0 	:
		case 1 	:
		default	:	usage() ;	return 1 ;
	}
}
